#!/usr/bin/env python

LOGFILE = '/opt/zope/Zope/var/pamlog.stuff'
import sys
sys.path.insert(0,'/opt/local/lib')
import PAM,time

class zopam:
	def __init__(self,User,Passwd,request):
		self.User = User
		self.Passwd = Passwd
		self.logstuff ="%s:%s:%s:%s" % (int(time.time()),User,request.PATH_TRANSLATED,request.REQUEST)
		

	def pam_conv(self,auth, query_list):
		resp = []
		for i in range(len(query_list)):
			query, type = query_list[i]
			if type == PAM.PAM_PROMPT_ECHO_ON:
				val = self.User
				resp.append(val, 0)
			elif type == PAM.PAM_PROMPT_ECHO_OFF:
				val = self.Passwd
				resp.append(val, 0)
			elif type == PAM.PAM_PROMPT_ERROR_MSG or type == PAM.PAM_PROMPT_TEXT_INFO:
				print query
				resp.append('', 0);
			else:
				return None
		return resp

	def checkpass(self):
		fd = open(LOGFILE,'a')
		#service = 'login'
		#service = 'ftp'
		service = 'zope'
		auth = PAM.pam()
		auth.start(service)
		auth.set_item(PAM.PAM_CONV, self.pam_conv)
		try:
			auth.authenticate()
			auth.acct_mgmt()
		except PAM.error, (resp, code):
			fd.write('%s:failed:errcode(%s):%s\n' % (self.logstuff,code,resp))
			fd.close()
			return 0
		except:
			fd.write(self.logstuff+':InternalError'+'\n')
			fd.close()
			print 'Internal error'
			return 0
		else:
			fd.write(self.logstuff+':success'+'\n')
			fd.close()
			return 1

